// 005 u_oracle_dbx_create_table
// 04 sep 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_oracle_dbx_create_table;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  ComCtrls, DBXpress, DB, SqlExpr, FMTBcd
  ;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    create_table_formations_: TButton;
    drop_table_formations_: TButton;
    Panel1: TPanel;
    Memo1: TMemo;
    SQLConnection1: TSQLConnection;
    SQLQuery1: TSQLQuery;
    exit_: TButton;
    clear_: TButton;
    create_dates_table_with_fk_: TButton;
    create_table_villes_: TButton;
    drop_villes_: TButton;
    drop_dates_: TButton;
    add_formations_constraint_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure create_table_formations_Click(Sender: TObject);
    procedure drop_table_formations_Click(Sender: TObject);
    procedure create_table_villes_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure drop_villes_Click(Sender: TObject);
    procedure create_dates_table_with_fk_Click(Sender: TObject);
    procedure add_formations_constraint_Click(Sender: TObject);
    procedure drop_dates_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    ;

{$R *.DFM}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.create_table_formations_Click(Sender: TObject);
      begin
        with SqlQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('CREATE TABLE formations');
            Add('  ('
                +'    f_numero INTEGER,');
            Add('     f_nom CHAR(23),');
            Add('     f_jours SMALLINT,');
            Add('     f_prix NUMERIC(7, 2)');
            // Add('     , f_lieu VARCHAR(30)');
            Add('   )');
          end; // with Sql

          display_strings(Sql);

          Try
            SqlConnection1.Open;

            display('Exec');
            ExecSql;

            display('  ok');
          except
            on e: Exception do
              begin
                display('  *** pb_create '+ e.Message);
              end;
          end;
        end; // with SqlQuery1
      end; // create_table_Click

    procedure TForm1.drop_table_formations_Click(Sender: TObject);
      begin
        with SQLQuery1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('DROP TABLE formations');
            display_strings(Sql);

            Try
              ExecSql;
              display('  ok');
            except
              on e: Exception do
                display('  *** pb '+ e.Message);
            end;
          end; // with Sql
        end; // with SQLQuery1
      end; // drop_table_Click

    procedure do_execute_sql(p_sql: String);
      begin
        with Form1, SqlQuery1, Sql do
        begin
          Close;

          Clear;
          Add(p_sql);

          display(p_sql);

          Try
            SqlConnection1.Open;

            display('Exec');
            ExecSql;

            display('  ok');
          except
            on e: Exception do
              begin
                display('  *** pb_create '+ e.Message);
              end;
          end;
        end; // with SqlQuery1
      end; // do_execute_sql

    procedure TForm1.create_table_villes_Click(Sender: TObject);
      begin
        do_execute_sql('CREATE TABLE villes'
           + '  ('
           + '    v_numero INTEGER NOT NULL PRIMARY KEY,'
           + '    v_nom CHAR(30)'
           + '  )');
      end; // create_table_villes_Click

    procedure TForm1.drop_villes_Click(Sender: TObject);
      begin
        do_execute_sql('DROP TABLE villes');
      end; // drop_villes_Click

    procedure TForm1.add_formations_constraint_Click(Sender: TObject);
      begin
        do_execute_sql(
            'ALTER TABLE formations'
          + '  ADD CONSTRAINT pk_formation PRIMARY KEY (f_numero)'
          );
      end; // add_formations_constraint_Click

    procedure TForm1.create_dates_table_with_fk_Click(Sender: TObject);
      begin
        do_execute_sql('CREATE TABLE dates'
           + '  ('
           + '    d_formation_ref INTEGER,'
           + '    d_ville_ref INTEGER,'
           + '    d_date DATE'
           + ',    CONSTRAINT fk_formation FOREIGN KEY (d_formation_ref) REFERENCES formations (f_numero)'
           + ',    CONSTRAINT fk_ville FOREIGN KEY (d_ville_ref) REFERENCES villes (v_numero)'
           + '  )');
      end; // create_dates_table_with_fk_Click

    procedure TForm1.drop_dates_Click(Sender: TObject);
      begin
        do_execute_sql('DROP TABLE dates');
      end; // drop_dates_Click

end.


